package jemu.system.cpc;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import jemu.ui.CPCFileFilter;

/**
 * Merge to dsk files into a single double sided!
 * 
 * @author Roland.Barthel
 */
public class CPCDiscImageMerger {

  /**
   * @param args
   */
  private static CPCFileFilter fileFilter;
  
  public static void merge(){//(final String[] args) {

    // choose first dsk file
    final JFileChooser fc = new JFileChooser();
      fileFilter = new CPCFileFilter();
      fc.setFileFilter(fileFilter);
    fc.setSelectedFile(new File(System.getProperty("user.dir")));
    fc.setFileSelectionMode(JFileChooser.FILES_ONLY);
    fc.setDialogTitle("Select first dsk file...");
    int result = fc.showOpenDialog(null);
    if (result != 1){
    final String firstFileName = fc.getSelectedFile().getAbsolutePath();
    
    // choose second dsk file
    fc.setDialogTitle("Select second dsk file...");
    result = fc.showOpenDialog(null);
    final String secondFileName = fc.getSelectedFile().getAbsolutePath();

    // choose destination file
    fc.setDialogTitle("Select destination dsk file...");
    result = fc.showSaveDialog(null);
    final String newFileName = fc.getSelectedFile().getAbsolutePath();

    // open dsk files
    try {
      final CPCDiscImageForMerge firstImage = openImage(firstFileName);
      final CPCDiscImageForMerge secondImage = openImage(secondFileName);
      final CPCDiscImageForMerge newImage = new CPCDiscImageForMerge(newFileName, firstImage, secondImage);
      newImage.saveImage();
    } catch (final IOException iox) {
      JOptionPane.showMessageDialog(null, iox.getMessage(), "Guru meditation!", JOptionPane.ERROR_MESSAGE);
    }

    // exit OK
    //System.exit(0);
  }}

  private static CPCDiscImageForMerge openImage(final String fileName) throws IOException {
    final BufferedInputStream bis = new BufferedInputStream(new FileInputStream(fileName));
    return CPCDiscImageForMerge.create(fileName, bis);
  }

}
